// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: GenericOperation
// Author: Hassan Siddiqui
//
// Description: Computes simple statistics on-the-fly from a given input data list.
// 
// Comments: 
//  
// Modifications: See ChangeLog
// 
// $Id: GenericOperation.h,v 1.4 1999/09/15 07:59:39 hsiddiqu Exp $


#ifndef GENERICOPERATION_H
#define GENERICOPERATION_H

// SAS-specific classes
#include "Dal.h"

// Utility functions
#include "errstr.h"
#include "Tracer.h"

//============================================================================

// NAMEOFGENERICBLOCK should be the name of another 
// macro accepting an argument of type Dal::DataType.

//============================================================================

#define GENERIC_OPERATION(NAMEOFGENERICBLOCK, TYPEFUNCTION)\
switch (TYPEFUNCTION) {\
			 case Data::Int8   : { NAMEOFGENERICBLOCK ## (int8);   break; }\
	                 case Data::Int16  : { NAMEOFGENERICBLOCK ## (int16);  break; }\
	                 case Data::Int32  : { NAMEOFGENERICBLOCK ## (int32);  break; }\
	                 case Data::Real32 : { NAMEOFGENERICBLOCK ## (real32); break; }\
	                 case Data::Real64 : { NAMEOFGENERICBLOCK ## (real64); break; }\
			 default: { errstr << " A data type of " << int(TYPEFUNCTION) << " is not supported. " << Sas::error("invalidDataType");} } 

#endif
